"""
    Delphix DCT API

    Delphix DCT API  # noqa: E501

    The version of the OpenAPI document: 3.12.0
    Contact: support@delphix.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from delphix.api.gateway.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
)
from ..model_utils import OpenApiModel
from delphix.api.gateway.exceptions import ApiAttributeError



class EnginePerformanceAnalytic(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('engine_type',): {
            'VIRTUALIZATION': "VIRTUALIZATION",
            'MASKING': "MASKING",
            'UNSET': "UNSET",
        },
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'engine_name': (str,),  # noqa: E501
            'engine_id': (str,),  # noqa: E501
            'engine_type': (str,),  # noqa: E501
            'aggregation_period': (int,),  # noqa: E501
            'cpu_cores_count': (int,),  # noqa: E501
            'cpu_utilization': (float,),  # noqa: E501
            'total_memory': (int,),  # noqa: E501
            'average_disk_latency_read': (int,),  # noqa: E501
            'average_disk_latency_write': (int,),  # noqa: E501
            'average_disk_latency_total': (int,),  # noqa: E501
            'average_disk_throughput_read': (int,),  # noqa: E501
            'average_disk_throughput_write': (int,),  # noqa: E501
            'average_disk_throughput_total': (int,),  # noqa: E501
            'average_disk_iops_read': (int,),  # noqa: E501
            'average_disk_iops_write': (int,),  # noqa: E501
            'average_disk_iops_total': (int,),  # noqa: E501
            'average_nfs_latency_read': (int,),  # noqa: E501
            'average_nfs_latency_write': (int,),  # noqa: E501
            'average_nfs_latency_total': (int,),  # noqa: E501
            'average_nfs_throughput_read': (int,),  # noqa: E501
            'average_nfs_throughput_write': (int,),  # noqa: E501
            'average_nfs_throughput_total': (int,),  # noqa: E501
            'average_nfs_iops_read': (int,),  # noqa: E501
            'average_nfs_iops_write': (int,),  # noqa: E501
            'average_nfs_iops_total': (int,),  # noqa: E501
            'average_iscsi_latency_read': (int,),  # noqa: E501
            'average_iscsi_latency_write': (int,),  # noqa: E501
            'average_iscsi_latency_total': (int,),  # noqa: E501
            'average_iscsi_throughput_read': (int,),  # noqa: E501
            'average_iscsi_throughput_write': (int,),  # noqa: E501
            'average_iscsi_throughput_total': (int,),  # noqa: E501
            'average_iscsi_iops_read': (int,),  # noqa: E501
            'average_iscsi_iops_write': (int,),  # noqa: E501
            'average_iscsi_iops_total': (int,),  # noqa: E501
            'average_network_throughput_transmit': (int,),  # noqa: E501
            'average_network_throughput_receive': (int,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'engine_name': 'engine_name',  # noqa: E501
        'engine_id': 'engine_id',  # noqa: E501
        'engine_type': 'engine_type',  # noqa: E501
        'aggregation_period': 'aggregation_period',  # noqa: E501
        'cpu_cores_count': 'cpu_cores_count',  # noqa: E501
        'cpu_utilization': 'cpu_utilization',  # noqa: E501
        'total_memory': 'total_memory',  # noqa: E501
        'average_disk_latency_read': 'average_disk_latency_read',  # noqa: E501
        'average_disk_latency_write': 'average_disk_latency_write',  # noqa: E501
        'average_disk_latency_total': 'average_disk_latency_total',  # noqa: E501
        'average_disk_throughput_read': 'average_disk_throughput_read',  # noqa: E501
        'average_disk_throughput_write': 'average_disk_throughput_write',  # noqa: E501
        'average_disk_throughput_total': 'average_disk_throughput_total',  # noqa: E501
        'average_disk_iops_read': 'average_disk_iops_read',  # noqa: E501
        'average_disk_iops_write': 'average_disk_iops_write',  # noqa: E501
        'average_disk_iops_total': 'average_disk_iops_total',  # noqa: E501
        'average_nfs_latency_read': 'average_nfs_latency_read',  # noqa: E501
        'average_nfs_latency_write': 'average_nfs_latency_write',  # noqa: E501
        'average_nfs_latency_total': 'average_nfs_latency_total',  # noqa: E501
        'average_nfs_throughput_read': 'average_nfs_throughput_read',  # noqa: E501
        'average_nfs_throughput_write': 'average_nfs_throughput_write',  # noqa: E501
        'average_nfs_throughput_total': 'average_nfs_throughput_total',  # noqa: E501
        'average_nfs_iops_read': 'average_nfs_iops_read',  # noqa: E501
        'average_nfs_iops_write': 'average_nfs_iops_write',  # noqa: E501
        'average_nfs_iops_total': 'average_nfs_iops_total',  # noqa: E501
        'average_iscsi_latency_read': 'average_iscsi_latency_read',  # noqa: E501
        'average_iscsi_latency_write': 'average_iscsi_latency_write',  # noqa: E501
        'average_iscsi_latency_total': 'average_iscsi_latency_total',  # noqa: E501
        'average_iscsi_throughput_read': 'average_iscsi_throughput_read',  # noqa: E501
        'average_iscsi_throughput_write': 'average_iscsi_throughput_write',  # noqa: E501
        'average_iscsi_throughput_total': 'average_iscsi_throughput_total',  # noqa: E501
        'average_iscsi_iops_read': 'average_iscsi_iops_read',  # noqa: E501
        'average_iscsi_iops_write': 'average_iscsi_iops_write',  # noqa: E501
        'average_iscsi_iops_total': 'average_iscsi_iops_total',  # noqa: E501
        'average_network_throughput_transmit': 'average_network_throughput_transmit',  # noqa: E501
        'average_network_throughput_receive': 'average_network_throughput_receive',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """EnginePerformanceAnalytic - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            engine_name (str): The engine name.. [optional]  # noqa: E501
            engine_id (str): The engine id.. [optional]  # noqa: E501
            engine_type (str): The engine type.. [optional]  # noqa: E501
            aggregation_period (int): The time period by which engine performance analytics data is being aggregated, in hours.. [optional]  # noqa: E501
            cpu_cores_count (int): The total number of CPU cores on this engine.. [optional]  # noqa: E501
            cpu_utilization (float): The total cpu utilization of this engine, in percentage.. [optional]  # noqa: E501
            total_memory (int): The total amount of memory on this engine, in bytes.. [optional]  # noqa: E501
            average_disk_latency_read (int): The average I/O latency of disk for read operation, in nanoseconds.. [optional]  # noqa: E501
            average_disk_latency_write (int): The average I/O latency of disk for write operation, in nanoseconds.. [optional]  # noqa: E501
            average_disk_latency_total (int): The average I/O latency of disk for both (read and write) operations, in nanoseconds.. [optional]  # noqa: E501
            average_disk_throughput_read (int): The average I/O throughput of disk for read operation, in bytes/s.. [optional]  # noqa: E501
            average_disk_throughput_write (int): The average I/O throughput of disk for write operation, in bytes/s.. [optional]  # noqa: E501
            average_disk_throughput_total (int): The average I/O throughput of disk for both (read and write) operations, in bytes/s.. [optional]  # noqa: E501
            average_disk_iops_read (int): The average number of read I/O operations of disk per seconds.. [optional]  # noqa: E501
            average_disk_iops_write (int): The average number of write I/O operations of disk per seconds.. [optional]  # noqa: E501
            average_disk_iops_total (int): The average number of read and write I/O operations of disk per seconds.. [optional]  # noqa: E501
            average_nfs_latency_read (int): The average I/O latency of nfs for read operation, in nanoseconds.. [optional]  # noqa: E501
            average_nfs_latency_write (int): The average I/O latency of nfs for write operation, in nanoseconds.. [optional]  # noqa: E501
            average_nfs_latency_total (int): The average I/O latency of nfs for both (read and write) operation, in nanoseconds.. [optional]  # noqa: E501
            average_nfs_throughput_read (int): The average I/O throughput of disk for read operations, in bytes/s.. [optional]  # noqa: E501
            average_nfs_throughput_write (int): The average I/O throughput of nfs for write operations, in bytes/s.. [optional]  # noqa: E501
            average_nfs_throughput_total (int): The average I/O throughput of nfs for both (read and write) operations, in bytes/s.. [optional]  # noqa: E501
            average_nfs_iops_read (int): The average number of read I/O operations of nfs per seconds.. [optional]  # noqa: E501
            average_nfs_iops_write (int): The average number of write I/O operations of nfs per seconds.. [optional]  # noqa: E501
            average_nfs_iops_total (int): The average number of read and write I/O operations of nfs per seconds.. [optional]  # noqa: E501
            average_iscsi_latency_read (int): The average I/O latency of iSCSI for read operation, in nanoseconds.. [optional]  # noqa: E501
            average_iscsi_latency_write (int): The average I/O latency of iSCSI for write operation, in nanoseconds.. [optional]  # noqa: E501
            average_iscsi_latency_total (int): The average I/O latency of iSCSI for both (read and write) operation, in nanoseconds.. [optional]  # noqa: E501
            average_iscsi_throughput_read (int): The average I/O throughput of iSCSI read operations, in bytes/s.. [optional]  # noqa: E501
            average_iscsi_throughput_write (int): The average I/O throughput of iSCSI for write operations, in bytes/s.. [optional]  # noqa: E501
            average_iscsi_throughput_total (int): The average I/O throughput of iSCSI for both (read and write) operations, in bytes/s.. [optional]  # noqa: E501
            average_iscsi_iops_read (int): The average number of read I/O operations of iSCSI per seconds.. [optional]  # noqa: E501
            average_iscsi_iops_write (int): The average number of write I/O operations of iSCSI per seconds.. [optional]  # noqa: E501
            average_iscsi_iops_total (int): The average number of read and write I/O operations of iSCSI per seconds.. [optional]  # noqa: E501
            average_network_throughput_transmit (int): The average bytes transmitted on the network interface, in bytes/s.. [optional]  # noqa: E501
            average_network_throughput_receive (int): The average bytes received on the network interface, in bytes/s.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """EnginePerformanceAnalytic - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            engine_name (str): The engine name.. [optional]  # noqa: E501
            engine_id (str): The engine id.. [optional]  # noqa: E501
            engine_type (str): The engine type.. [optional]  # noqa: E501
            aggregation_period (int): The time period by which engine performance analytics data is being aggregated, in hours.. [optional]  # noqa: E501
            cpu_cores_count (int): The total number of CPU cores on this engine.. [optional]  # noqa: E501
            cpu_utilization (float): The total cpu utilization of this engine, in percentage.. [optional]  # noqa: E501
            total_memory (int): The total amount of memory on this engine, in bytes.. [optional]  # noqa: E501
            average_disk_latency_read (int): The average I/O latency of disk for read operation, in nanoseconds.. [optional]  # noqa: E501
            average_disk_latency_write (int): The average I/O latency of disk for write operation, in nanoseconds.. [optional]  # noqa: E501
            average_disk_latency_total (int): The average I/O latency of disk for both (read and write) operations, in nanoseconds.. [optional]  # noqa: E501
            average_disk_throughput_read (int): The average I/O throughput of disk for read operation, in bytes/s.. [optional]  # noqa: E501
            average_disk_throughput_write (int): The average I/O throughput of disk for write operation, in bytes/s.. [optional]  # noqa: E501
            average_disk_throughput_total (int): The average I/O throughput of disk for both (read and write) operations, in bytes/s.. [optional]  # noqa: E501
            average_disk_iops_read (int): The average number of read I/O operations of disk per seconds.. [optional]  # noqa: E501
            average_disk_iops_write (int): The average number of write I/O operations of disk per seconds.. [optional]  # noqa: E501
            average_disk_iops_total (int): The average number of read and write I/O operations of disk per seconds.. [optional]  # noqa: E501
            average_nfs_latency_read (int): The average I/O latency of nfs for read operation, in nanoseconds.. [optional]  # noqa: E501
            average_nfs_latency_write (int): The average I/O latency of nfs for write operation, in nanoseconds.. [optional]  # noqa: E501
            average_nfs_latency_total (int): The average I/O latency of nfs for both (read and write) operation, in nanoseconds.. [optional]  # noqa: E501
            average_nfs_throughput_read (int): The average I/O throughput of disk for read operations, in bytes/s.. [optional]  # noqa: E501
            average_nfs_throughput_write (int): The average I/O throughput of nfs for write operations, in bytes/s.. [optional]  # noqa: E501
            average_nfs_throughput_total (int): The average I/O throughput of nfs for both (read and write) operations, in bytes/s.. [optional]  # noqa: E501
            average_nfs_iops_read (int): The average number of read I/O operations of nfs per seconds.. [optional]  # noqa: E501
            average_nfs_iops_write (int): The average number of write I/O operations of nfs per seconds.. [optional]  # noqa: E501
            average_nfs_iops_total (int): The average number of read and write I/O operations of nfs per seconds.. [optional]  # noqa: E501
            average_iscsi_latency_read (int): The average I/O latency of iSCSI for read operation, in nanoseconds.. [optional]  # noqa: E501
            average_iscsi_latency_write (int): The average I/O latency of iSCSI for write operation, in nanoseconds.. [optional]  # noqa: E501
            average_iscsi_latency_total (int): The average I/O latency of iSCSI for both (read and write) operation, in nanoseconds.. [optional]  # noqa: E501
            average_iscsi_throughput_read (int): The average I/O throughput of iSCSI read operations, in bytes/s.. [optional]  # noqa: E501
            average_iscsi_throughput_write (int): The average I/O throughput of iSCSI for write operations, in bytes/s.. [optional]  # noqa: E501
            average_iscsi_throughput_total (int): The average I/O throughput of iSCSI for both (read and write) operations, in bytes/s.. [optional]  # noqa: E501
            average_iscsi_iops_read (int): The average number of read I/O operations of iSCSI per seconds.. [optional]  # noqa: E501
            average_iscsi_iops_write (int): The average number of write I/O operations of iSCSI per seconds.. [optional]  # noqa: E501
            average_iscsi_iops_total (int): The average number of read and write I/O operations of iSCSI per seconds.. [optional]  # noqa: E501
            average_network_throughput_transmit (int): The average bytes transmitted on the network interface, in bytes/s.. [optional]  # noqa: E501
            average_network_throughput_receive (int): The average bytes received on the network interface, in bytes/s.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
